package com.example.kafka.service;

import com.example.kafka.entity.User;
import com.example.kafka.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class UserServiceImpl implements UserService {

    @Autowired
    private UserRepository userRepository;

    @Override
    public Mono<User> createUser(User user){
        return userRepository.save(user);
    }

    @Override
    public Flux<User> getAllUsers(){
        return userRepository.findAll();
    }

    @Override
    public Mono<User> findById(String userId){
        return userRepository.findById(userId);
    }

    @Override
    public Mono<User> updateUser(String userId,  User user){
        return userRepository.findById(userId)
                .flatMap(dbUser -> {
                    dbUser.setAge(user.getAge());
                    dbUser.setBalance(user.getBalance());
                    return userRepository.save(dbUser);
                });
    }
}
